Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Parameters.h	(revision 88)
@@ -31,8 +31,11 @@
 			bool     encoding_one_hot,
 			bool     encoding_compact);
-  public : Parameters  (Parameters & param) ;
+//   public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
 
+  public :        void            copy       (void);
+
   public :        Parameters_test msg_error  (void);
+
   public :        std::string   print      (uint32_t depth);
   public : friend std::ostream& operator<< (std::ostream& output_stream,
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Parameters.cpp	(revision 88)
@@ -28,14 +28,14 @@
   };
   
-  Parameters::Parameters (Parameters & param):
-    _nb_entity        (param._nb_entity       ),
-    _encoding_one_hot (param._encoding_one_hot),
-    _encoding_compact (param._encoding_compact),
-    _size_entity      (param._size_entity     )
-  {
-    log_printf(FUNC,Select_Priority_Fixed,"Parameters","Begin");
-    test();
-    log_printf(FUNC,Select_Priority_Fixed,"Parameters","End");
-  };
+//   Parameters::Parameters (Parameters & param):
+//     _nb_entity        (param._nb_entity       ),
+//     _encoding_one_hot (param._encoding_one_hot),
+//     _encoding_compact (param._encoding_compact),
+//     _size_entity      (param._size_entity     )
+//   {
+//     log_printf(FUNC,Select_Priority_Fixed,"Parameters","Begin");
+//     test();
+//     log_printf(FUNC,Select_Priority_Fixed,"Parameters","End");
+//   };
 
   Parameters::~Parameters () 
@@ -43,4 +43,10 @@
     log_printf(FUNC,Select_Priority_Fixed,"~Parameters","Begin");
     log_printf(FUNC,Select_Priority_Fixed,"~Parameters","End");
+  };
+
+  void Parameters::copy (void) 
+  {
+    log_printf(FUNC,Select_Priority_Fixed,"copy","Begin");
+    log_printf(FUNC,Select_Priority_Fixed,"copy","End");
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed.cpp	(revision 88)
@@ -2,5 +2,5 @@
  * $Id$
  *
- * [ Description ]
+ * [ Description ]
  * 
  */
@@ -33,9 +33,15 @@
     log_printf(FUNC,Select_Priority_Fixed,"Select_Priority_Fixed","Begin");
 
+#if DEBUG_Select_Priority_Fixed == true
+    log_printf(INFO,Select_Priority_Fixed,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif    
+
     log_printf(INFO,Select_Priority_Fixed,"Select_Priority_Fixed","Allocation");
     allocation ();
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {
 	log_printf(INFO,Select_Priority_Fixed,"Select_Priority_Fixed","Allocation of statistics");
@@ -46,13 +52,16 @@
 
 #ifdef VHDL
-    // generate the vhdl
-    log_printf(INFO,Select_Priority_Fixed,"Select_Priority_Fixed","Generate the vhdl");
-
-    vhdl();
+    if (usage_is_set(_usage,USE_VHDL)
+      {
+        // generate the vhdl
+        log_printf(INFO,Select_Priority_Fixed,"Select_Priority_Fixed","Generate the vhdl");
+        
+        vhdl();
+      }
 #endif
 
 #ifdef SYSTEMC
-    if (_usage & USE_SYSTEMC)
-      {
+      if (usage_is_set(_usage,USE_SYSTEMC))
+        {
 #  if defined(STATISTICS) or defined(VHDL_TESTBENCH)
 	log_printf(INFO,Select_Priority_Fixed,"Select_Priority_Fixed","Method - transition");
@@ -96,5 +105,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {
 	log_printf(INFO,Select_Priority_Fixed,"~Select_Priority_Fixed","Generate Statistics file");
@@ -104,9 +113,6 @@
 #endif
 
-#ifdef SYSTEMC
     log_printf(INFO,Select_Priority_Fixed,"~Select_Priority_Fixed","Deallocation");
-
     deallocation ();
-#endif
 
     log_printf(FUNC,Select_Priority_Fixed,"~Select_Priority_Fixed","End");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_allocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_allocation.cpp	(revision 88)
@@ -1,3 +1,2 @@
-#ifdef SYSTEMC
 /*
  * $Id$
@@ -30,5 +29,5 @@
     _interfaces = entity->set_interfaces();
 
-    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+    // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
     Interface_fifo * interface = _interfaces->set_interface(""
@@ -63,5 +62,6 @@
 
 #ifdef POSITION
-    _component->generate_file();
+    if (usage_is_set(_usage,USE_POSITION))
+      _component->generate_file();
 #endif
 
@@ -74,3 +74,2 @@
 }; // end namespace behavioural
 }; // end namespace morpheo              
-#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_deallocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_deallocation.cpp	(revision 88)
@@ -1,3 +1,2 @@
-#ifdef SYSTEMC
 /*
  * $Id$
@@ -20,5 +19,5 @@
     log_printf(FUNC,Select_Priority_Fixed,"deallocation","Begin");
 
-    if (_usage & USE_SYSTEMC)
+    if (usage_is_set(_usage,USE_SYSTEMC))
       {
 	delete     in_CLOCK;
@@ -48,3 +47,2 @@
 }; // end namespace behavioural
 }; // end namespace morpheo              
-#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_end_cycle.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_end_cycle.cpp	(revision 88)
@@ -22,5 +22,6 @@
 
 #ifdef STATISTICS
-    _stat->end_cycle();
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
 #endif    
 
@@ -28,5 +29,6 @@
     // Evaluation before read the ouput signal
 //  sc_start(0);
-    _interfaces->testbench();
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/Makefile	(revision 88)
@@ -23,4 +23,6 @@
 library_clean			: Shifter_library_clean
 
+local_clean			:
+
 include                         ../Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/src/test.cpp	(revision 88)
@@ -38,4 +38,15 @@
   morpheo::behavioural::Parameters_Statistics * param_stat = new morpheo::behavioural::Parameters_Statistics(5,50);
 #endif
+
+  Tusage_t _usage = USE_ALL;
+
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+   _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
+
   Shifter * _Shifter = new Shifter (name.c_str(),
 #ifdef STATISTICS
@@ -43,5 +54,5 @@
 #endif
 				    &param,
-				    USE_ALL);
+				    _usage);
   
 #ifdef SYSTEMC
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Parameters.h	(revision 88)
@@ -56,8 +56,11 @@
 			carry_t     carry               ,
 			bool        type_completion_bool = false);
-  public : Parameters  (Parameters & param) ;
+//   public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
 
+  public :        void            copy       (void);
+
   public :        Parameters_test msg_error  (void);
+
   public :        std::string     print      (uint32_t depth);
   public : friend std::ostream&   operator<< (std::ostream& output_stream,
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Parameters.cpp	(revision 88)
@@ -80,38 +80,43 @@
   };
   
-  Parameters::Parameters (Parameters & param):
-    _size_data                   (param._size_data                   ),
-    _nb_port                     (param._nb_port                     ),
-    _shift_value                 (param._shift_value                 ),
-    _rotate                      (param._rotate                      ),
-    _direction                   (param._direction                   ),
-    _carry                       (param._carry                       ),
-    _size_data_completion        (param._size_data_completion        ),
-    _type_completion_bool        (param._type_completion_bool        ),
+//   Parameters::Parameters (Parameters & param):
+//     _size_data                   (param._size_data                   ),
+//     _nb_port                     (param._nb_port                     ),
+//     _shift_value                 (param._shift_value                 ),
+//     _rotate                      (param._rotate                      ),
+//     _direction                   (param._direction                   ),
+//     _carry                       (param._carry                       ),
+//     _size_data_completion        (param._size_data_completion        ),
+//     _type_completion_bool        (param._type_completion_bool        ),
 
-    _internal_direction          (param._internal_direction          ),
-    _internal_type               (param._internal_type               ),
-    _internal_carry              (param._internal_carry              ),
+//     _internal_direction          (param._internal_direction          ),
+//     _internal_type               (param._internal_type               ),
+//     _internal_carry              (param._internal_carry              ),
     
-    _have_shift_logic_left       (param._have_shift_logic_left       ),
-    _have_shift_logic_right      (param._have_shift_logic_right      ),
-    _have_shift_logic            (param._have_shift_logic            ),
-    _have_shift_arithmetic_left  (param._have_shift_arithmetic_left  ),
-    _have_shift_arithmetic_right (param._have_shift_arithmetic_right ),
-    _have_shift_arithmetic       (param._have_shift_arithmetic       ),
-    _have_shift                  (param._have_shift                  ),
-    _have_rotate_left            (param._have_rotate_left            ),
-    _have_rotate_right           (param._have_rotate_right           ),
-    _have_rotate                 (param._have_rotate                 ),
+//     _have_shift_logic_left       (param._have_shift_logic_left       ),
+//     _have_shift_logic_right      (param._have_shift_logic_right      ),
+//     _have_shift_logic            (param._have_shift_logic            ),
+//     _have_shift_arithmetic_left  (param._have_shift_arithmetic_left  ),
+//     _have_shift_arithmetic_right (param._have_shift_arithmetic_right ),
+//     _have_shift_arithmetic       (param._have_shift_arithmetic       ),
+//     _have_shift                  (param._have_shift                  ),
+//     _have_rotate_left            (param._have_rotate_left            ),
+//     _have_rotate_right           (param._have_rotate_right           ),
+//     _have_rotate                 (param._have_rotate                 ),
 
-    _have_direction_left         (param._have_direction_left         ),
-    _have_direction_right        (param._have_direction_right        )
+//     _have_direction_left         (param._have_direction_left         ),
+//     _have_direction_right        (param._have_direction_right        )
 
+//   {
+//     test();
+//   };
+
+  Parameters::~Parameters () 
   {
-    test();
   };
 
-  Parameters::~Parameters () 
-  { };
+  void Parameters::copy (void) 
+  {
+  };
 
 }; // end namespace shifter
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter.cpp	(revision 88)
@@ -14,4 +14,6 @@
 
 
+#undef  FUNCTION
+#define FUNCTION "Shifter::Shifter"
   Shifter::Shifter (
 #ifdef SYSTEMC
@@ -29,19 +31,32 @@
     ,_usage (usage)
   {
-#ifdef SYSTEMC
+
+#if DEBUG_Shifter == true
+    log_printf(INFO,Shifter,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif    
+
     allocation ();
-#endif
 
 #ifdef STATISTICS
-    // Allocation of statistics
-    statistics_declaration(param_statistics);
+    if (usage_is_set(_usage,USE_STATISTICS))
+      {
+        // Allocation of statistics
+        statistics_declaration(param_statistics);
+      }
 #endif
 
 #ifdef VHDL
-    // generate the vhdl
-    vhdl();
+    if (usage_is_set(_usage,USE_VHDL))
+      {
+        // generate the vhdl
+        vhdl();
+      }
 #endif
 
 #ifdef SYSTEMC
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {
 #if (defined(STATISTICS) || defined (VHDL_TESTBENCH))
     SC_METHOD (transition);
@@ -91,17 +106,18 @@
       }
 #endif    
-
+      }
 #endif
   };
   
+#undef  FUNCTION
+#define FUNCTION "Shifter::~Shifter"
   Shifter::~Shifter (void)
   {
-#ifdef SYSTEMC
-    deallocation ();
+#ifdef STATISTICS
+    if (usage_is_set(_usage,USE_STATISTICS))
+      delete _stat;
 #endif
 
-#ifdef STATISTICS
-    delete _stat;
-#endif
+    deallocation ();
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_allocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_allocation.cpp	(revision 88)
@@ -1,3 +1,2 @@
-#ifdef SYSTEMC
 /*
  * $Id$
@@ -86,9 +85,10 @@
 	   in_SHIFTER_COMPLETION [i] = interface->set_signal_in  <Tdata_t     > ("completion",_param->_size_data_completion);
 	  out_SHIFTER_DATA       [i] = interface->set_signal_out <Tdata_t     > ("data"      ,_param->_size_data);
-	}										                                         
+	}
     }
 
 #ifdef POSITION
-    _component->generate_file();
+    if (usage_is_set(_usage,USE_POSITION))
+      _component->generate_file();
 #endif
 
@@ -99,3 +99,2 @@
 }; // end namespace behavioural
 }; // end namespace morpheo              
-#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_deallocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_deallocation.cpp	(revision 88)
@@ -1,3 +1,2 @@
-#ifdef SYSTEMC
 /*
  * $Id$
@@ -17,4 +16,6 @@
   void Shifter::deallocation (void)
   {
+    if (usage_is_set(_usage,USE_SYSTEMC))
+      {	
 #if (defined(STATISTICS) || defined (VHDL_TESTBENCH))
     delete     in_CLOCK;
@@ -36,4 +37,5 @@
     delete []  in_SHIFTER_COMPLETION;
     delete [] out_SHIFTER_DATA      ;
+      }
 
     delete _component;
@@ -46,3 +48,2 @@
 }; // end namespace behavioural
 }; // end namespace morpheo              
-#endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_end_cycle.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_end_cycle.cpp	(revision 88)
@@ -21,5 +21,6 @@
 
 #ifdef STATISTICS
-    _stat->end_cycle();
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
 #endif    
 
@@ -27,5 +28,6 @@
     // Evaluation before read the ouput signal
 //  sc_start(0);
-    _interfaces->testbench();
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/SelfTest/Makefile	(revision 88)
@@ -24,4 +24,6 @@
 library_clean			: Sort_library_clean
 
+local_clean			:
+
 include                         $(DIR_COMPONENT)/Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/SelfTest/src/test.cpp	(revision 88)
@@ -31,4 +31,14 @@
 #endif
 
+  Tusage_t _usage = USE_ALL;
+
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+//   _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
+
   Sort * _Sort = new Sort (name.c_str(),
 #ifdef STATISTICS
@@ -36,5 +46,5 @@
 #endif
 			   _param,
-			   USE_ALL);
+			   _usage);
   
 #ifdef SYSTEMC
@@ -154,5 +164,5 @@
 	      tab [ptr]._val = false;
 
-	      LABEL("OUTPUT [%d] %d - %d",i, out_OUTPUT_VAL [i]->read(), out_OUTPUT_DATA [i]->read(), out_OUTPUT_INDEX [i]->read());
+	      LABEL("OUTPUT [%d] %d %d - %d",i, out_OUTPUT_VAL [i]->read(), out_OUTPUT_DATA [i]->read(), out_OUTPUT_INDEX [i]->read());
 
 	      TEST(Tcontrol_t,out_OUTPUT_VAL   [i]->read(),find);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/include/Parameters.h	(revision 88)
@@ -42,4 +42,6 @@
   public : ~Parameters () ;
 
+  public :        void            copy       (void);
+
   public :        Parameters_test msg_error  (void);
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Parameters.cpp	(revision 88)
@@ -55,4 +55,12 @@
   };
 
+#undef  FUNCTION
+#define FUNCTION "Sort::copy"
+  void Parameters::copy (void) 
+  {
+    log_printf(FUNC,Sort,FUNCTION,"Begin");
+    log_printf(FUNC,Sort,FUNCTION,"End");
+  };
+
 }; // end namespace sort
 }; // end namespace generic
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort.cpp	(revision 88)
@@ -35,4 +35,10 @@
     log_printf(FUNC,Sort,FUNCTION,"Begin");
 
+#if DEBUG_Sort == true
+    log_printf(INFO,Sort,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+    std::cout << *param << std::endl;
+#endif    
+
     log_printf(INFO,Sort,FUNCTION,"Allocation");
 
@@ -44,5 +50,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {	
 	log_printf(INFO,Sort,FUNCTION,"Allocation of statistics");
@@ -53,5 +59,5 @@
 
 #ifdef VHDL
-    if (_usage & USE_VHDL)
+    if (usage_is_set(_usage,USE_VHDL))
       {
 	// generate the vhdl
@@ -63,5 +69,5 @@
 
 #ifdef SYSTEMC
-    if (_usage & USE_SYSTEMC)
+    if (usage_is_set(_usage,USE_SYSTEMC))
       {
 	log_printf(INFO,Sort,FUNCTION,"Method - transition");
@@ -117,5 +123,5 @@
 
 #ifdef STATISTICS
-    if (_usage & USE_STATISTICS)
+    if (usage_is_set(_usage,USE_STATISTICS))
       {
 	statistics_deallocation();
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_allocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_allocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_allocation.cpp	(revision 88)
@@ -13,6 +13,4 @@
 namespace generic {
 namespace sort {
-
-
 
 #undef  FUNCTION
@@ -75,5 +73,6 @@
 
 #ifdef POSITION
-    _component->generate_file();
+    if (usage_is_set(_usage,USE_POSTION))
+      _component->generate_file();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_deallocation.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_deallocation.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_deallocation.cpp	(revision 88)
@@ -20,5 +20,5 @@
     log_printf(FUNC,Sort,FUNCTION,"Begin");
 
-    if (_usage & USE_SYSTEMC)
+    if (usage_is_set(_usage,USE_SYSTEMC))
       {
 	delete     in_CLOCK ;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_end_cycle.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_end_cycle.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Sort/src/Sort_end_cycle.cpp	(revision 88)
@@ -22,5 +22,6 @@
 
 #ifdef STATISTICS
-    _stat->end_cycle();
+    if (usage_is_set(_usage,USE_STATISTICS))
+      _stat->end_cycle();
 #endif    
 
@@ -28,5 +29,6 @@
     // Evaluation before read the ouput signal
 //  sc_start(0);
-    _interfaces->testbench();
+    if (usage_is_set(_usage,USE_VHDL_TESTBENCH))
+      _interfaces->testbench();
 #endif
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/SelfTest/Makefile	(revision 88)
@@ -24,4 +24,6 @@
 library_clean			: Victim_library_clean
 
+local_clean			:
+
 include                         $(DIR_COMPONENT)/Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/SelfTest/src/test.cpp	(revision 88)
@@ -23,4 +23,14 @@
 #endif
 
+  Tusage_t _usage = USE_ALL;
+
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+//   _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
+
   Victim * _Victim = new Victim (name.c_str(),
 #ifdef STATISTICS
@@ -28,5 +38,5 @@
 #endif
 				 _param,
-				 USE_ALL);
+				 _usage);
   
 #ifdef SYSTEMC
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/SelfTest/Makefile	(revision 88)
@@ -23,4 +23,6 @@
 library_clean			: Victim_Pseudo_LRU_library_clean
 
+local_clean			:
+
 include                         ../Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/SelfTest/src/test.cpp	(revision 88)
@@ -38,10 +38,21 @@
 #endif
 
-  Victim_Pseudo_LRU * _Victim_Pseudo_LRU = new Victim_Pseudo_LRU (name.c_str(),
+  Tusage_t _usage = USE_ALL;
+
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+//   _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
+
+  Victim_Pseudo_LRU * _Victim_Pseudo_LRU = new Victim_Pseudo_LRU 
+    (name.c_str(),
 #ifdef STATISTICS
-								  param_stat,
-#endif
-								  &param,
-								  USE_ALL);
+     param_stat,
+#endif
+     &param,
+     _usage);
   
 #ifdef SYSTEMC
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Parameters.h	(revision 88)
@@ -35,8 +35,11 @@
 			uint32_t size_table,
 			bool     table_global);
-  public : Parameters  (Parameters & param) ;
+//   public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
 
+  public :        void            copy       (void);
+
   public :        Parameters_test msg_error  (void);
+
   public :        std::string     print      (uint32_t depth);
   public : friend std::ostream&   operator<< (std::ostream& output_stream,
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h	(revision 88)
@@ -112,10 +112,10 @@
   public  :          ~Victim_Pseudo_LRU             (void);
 					       
-#ifdef SYSTEMC				       
   private : void     allocation                (void);
   private : void     deallocation              (void);
 					       
+#ifdef SYSTEMC				       
   public  : void     transition                (void);
-  public  : void     genMoore                  (void);
+  public  : void     genMealy                  (void);
 #endif
 					       
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters.cpp	(revision 88)
@@ -30,17 +30,22 @@
   };
   
-  Parameters::Parameters (Parameters & param):
-    _nb_entity  (param._nb_entity ),
-    _nb_access  (param._nb_access ),
-//     _nb_update  (param._nb_update ),
-    _size_table (param._size_table),
-    _table_global(param._table_global),
-    _size_address(param._size_address)
-  { 
-    test();
+//   Parameters::Parameters (Parameters & param):
+//     _nb_entity  (param._nb_entity ),
+//     _nb_access  (param._nb_access ),
+// //     _nb_update  (param._nb_update ),
+//     _size_table (param._size_table),
+//     _table_global(param._table_global),
+//     _size_address(param._size_address)
+//   { 
+//     test();
+//   };
+
+  Parameters::~Parameters () 
+  {
   };
 
-  Parameters::~Parameters () 
-  { };
+  void Parameters::copy (void) 
+  {
+  };
 
 }; // end namespace victim_pseudo_lru
